//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  White
#property indicator_color2  Aqua
#property indicator_color3  Yellow
#property indicator_level1  0

extern string TimeFrame          = "Current time frame";
extern int    NmrLength          = 20;
extern bool   WrongWay           = false;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = false;
extern bool   alertsOnZeroCross  = true;
extern bool   alertsOnBandCross  = true;
extern bool   alertsSound        = false;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsEmail        = false;
extern bool   Interpolate        = true;

//
//
//
//
//

double extmapbuffer1[];
double extmapbuffer2[];
double extmapbuffer3[];
double trendz[];
double trendu[];
double trendd[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer (0,extmapbuffer1);
   SetIndexBuffer (1,extmapbuffer2);
   SetIndexBuffer (2,extmapbuffer3);
   SetIndexBuffer (3,trendz);
   SetIndexBuffer (4,trendu);
   SetIndexBuffer (5,trendd);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" nmr ("+NmrLength+")");      
  return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
  int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-NmrLength-1);
         if (returnBars) { extmapbuffer1[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  extmapbuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,0,y);
                  extmapbuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,1,y);
                  extmapbuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,2,y);
                     
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                  //
                  //
                  //
                  //
                  //

                  datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int m = 1; m < n; m++)
                     {
                        extmapbuffer1[i+m] = extmapbuffer1[i] + (extmapbuffer1[i+n] - extmapbuffer1[i]) * m/n;
                        extmapbuffer2[i+m] = extmapbuffer2[i] + (extmapbuffer2[i+n] - extmapbuffer2[i]) * m/n;
                        extmapbuffer3[i+m] = extmapbuffer3[i] + (extmapbuffer3[i+n] - extmapbuffer3[i]) * m/n;
                     }               
            }
            return(0);
         }

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double sum=0,sum2=0,x=0,r=0;
      for (int k=0; k<NmrLength; k++)
      {
         if (k>0)
         {
            sum  += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
            sum2 += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000)*(MathSqrt(k+1)-MathSqrt(k));
         }
         else r += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
              x +=        (MathLog(Close[i]  )*100000 - MathLog(Close[i+k+1])*100000)/MathSqrt(k+1);
      }
      
      //
      //
      //
      //
      //
      
      r += sum2; x /= (NmrLength*1.0);  double ratio = 1; if (sum!=0) ratio = MathRound(sum2)/MathRound(sum);
         if (WrongWay)
            {
               extmapbuffer1[i] =  ratio*x;
               extmapbuffer2[i] =  ratio*ratio*r;
            }
         else
            {
               extmapbuffer1[i] =  extmapbuffer1[i+1]+ratio*(x-extmapbuffer1[i+1]);
               extmapbuffer2[i] =  extmapbuffer2[i+1]+ratio*(r*ratio - extmapbuffer2[i+1]);
            }         
            extmapbuffer3[i] = -extmapbuffer2[i];
            trendz[i] = trendz[i+1];
            trendu[i] = trendu[i+1];
            trendd[i] = trendd[i+1];
               if (extmapbuffer1[i]>0)                trendz[i] =  1;
               if (extmapbuffer1[i]<0)                trendz[i] = -1;
               if (extmapbuffer1[i]>extmapbuffer2[i]) trendu[i] =  1;
               if (extmapbuffer1[i]<extmapbuffer2[i]) trendu[i] = -1;
               if (extmapbuffer1[i]>extmapbuffer3[i]) trendd[i] =  1;
               if (extmapbuffer1[i]<extmapbuffer3[i]) trendd[i] = -1;
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
      if (alertsOnZeroCross && trendz[whichBar] != trendz[whichBar+1])
      {
         if (trendz[whichBar] ==  1) doAlert(alertType1,alertTime1,"nmr crossed level 0 up");
         if (trendz[whichBar] == -1) doAlert(alertType1,alertTime1,"nmr crossed level 0 down");
      }
      static string   alertType2 = "";
      static datetime alertTime2 = 0;
      if (alertsOnBandCross && trendu[whichBar] != trendu[whichBar+1])
      {
         if (trendu[whichBar] ==  1) doAlert(alertType2,alertTime2,"nmr crossed upper band up");
         if (trendu[whichBar] == -1) doAlert(alertType2,alertTime2,"nmr crossed upper band down");
      }
      static string   alertType3 = "";
      static datetime alertTime3 = 0;
      if (alertsOnBandCross && trendd[whichBar] != trendd[whichBar+1])
      {
         if (trendd[whichBar] ==  1) doAlert(alertType3,alertTime3,"nmr crossed lower band up");
         if (trendd[whichBar] == -1) doAlert(alertType3,alertTime3,"nmr crossed lower band down");
      }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"nmr"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"nmr "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}